Description

TMail class in ActionMailer::Base decodes subject to ISO-2022-JP when the subject is written in Japanese. But it should be utf8 when
set to issue.subject. As a result, we get broken subject like the attached picture.

Associated revisions
Revision 1990 - 2008-11-07 18:27 - Jean-Philippe Lang

Fixed: broken subject when submitting issue via email written in japanese (Patch #2059 by Go MAEDA).

History
#1 - 2008-11-07 18:27 - Jean-Philippe Lang
- Status changed from New to Closed

Patch applied in r1990. Thanks.

#2 - 2009-09-24 07:24 - Nobuhiro IMAI
- File mail_hander_broken_attachment_filename.diff added
- Status changed from Closed to Reopened

The same problem is on the filename of attachment files.
Attached patch fixes this in a similar way to mail_hander_broken_subject.diff.

However, I wonder where the String#toutf8 method came from.
Only kconv.rb (bundled in Ruby 1.8 series) defines String#toutf8,
and Redmine does not require this library, as far as I know.

Just in case, toutf8 from kconv uses nkf internally, 
NKF.nkf decodes MIME encoded string automatically.

>> NKF.nkf("-w", "=?iso-2022-jp?B?GyRCJCIkJCQmJCgkKhsoQg==?=")
=> "あいうえお" 
>> "=?iso-2022-jp?B?GyRCJCIkJCQmJCgkKhsoQg==?=".toutf8
=> "あいうえお" 
>> NKF.nkf("-w", "=?utf-8?Q?=E3=81=82=E3=81=84=E3=81=86=E3=81=88=E3=81=8A?=")
=> "あいうえお" 
>> "=?utf-8?Q?=E3=81=82=E3=81=84=E3=81=86=E3=81=88=E3=81=8A?=".toutf8
=> "あいうえお" 
#3 - 2009-10-07 18:00 - Ignacio Carrera

@Nobuhiro, please read #3717 (my comment specifically).

This change broke other non-JP and non-English encodings, plus I believe that TMail was handling your subject correctly (the problem may lie
elsewhere).

-- nachokb

#4 - 2009-10-19 17:32 - Ignacio Carrera

Ignacio Carrera wrote:

@Nobuhiro, please read #3717 (my comment specifically).

This change broke other non-JP and non-English encodings, plus I believe that TMail was handling your subject correctly (the problem may lie
elsewhere).

-- nachokb

Jean Philippe seems to have fixed it in sandbox some months ago...

#5 - 2011-11-28 05:07 - Mischa The Evil
- Category set to Email receiving

#6 - 2015-04-29 12:08 - Toshi MARUYAMA
- Related to deleted (Defect #4608: Mail attachment name encoding is incorectly handled)

#7 - 2015-04-29 12:09 - Toshi MARUYAMA

Original issue is fixed.
#2059#note-2 is duplicate of #4608.

#8 - 2015-04-29 12:09 - Toshi MARUYAMA
- Status changed from Reopened to Closed

Files
broken_subject.png 28.6 KB 2008-10-21 Go MAEDA
mail_hander_broken_subject.diff 628 Bytes 2008-10-21 Go MAEDA
mail_hander_broken_attachment_filename.diff 543 Bytes 2009-09-24 Nobuhiro IMAI

2022-01-29 2/2

http://www.redmine.org/issues/3717#note-11
http://www.redmine.org/issues/3717#note-11
http://www.redmine.org/projects/redmine/repository/revisions/2620/diff/sandbox/rails-2.3/app/models/mail_handler.rb

